/***************************************************************
From the book "Motif Programming, The Essentials...and More"
by Marshall Brain.
Published by Digital Press, ISBN 1-55558-089-0.
To order the book, call 1-800-DIGITAL and ask for EY-J816E-DP.

Copyright 1992, by Digital Equipment Corp.

This code demonstrates the retrieval of the default font
name from the default font list.
***************************************************************/

/* default_font.c */

#include <Xm/Xm.h>
#include <Xm/Label.h>

XtAppContext context;
XmStringCharSet char_set=XmSTRING_DEFAULT_CHARSET;

Widget toplevel, label;

void main(argc,argv)
    int argc; 
    char *argv[];
{
    Arg al[10];
    int ac;
    XmFontList fl;
    XFontStruct *font;
    XmFontContext font_context;

    /* create the toplevel shell */
    toplevel = XtAppInitialize(&context,"",NULL,0,&argc,argv,
        NULL,NULL,0);

    /* create the label widget */
    ac=0;
    label=XmCreateLabel(toplevel,"label",al,ac);
    XtManageChild(label);

    ac=0;
    XtSetArg(al[ac],XmNfontList,&fl); ac++;
    XtGetValues(label,al,ac);

    XmFontListInitFontContext(&font_context,fl);
    XmFontListGetNextFont(font_context,&char_set,&font);
    printf("%s\n",char_set);
}
